-- MyMahjongg Version 1.0
-- by Vincent Gonzales
-- This program uses a specialized form of PUTSXY() written by David Alan Gay
-- I think this program is pretty much debugged but... you're on your own!

include image.e
include file.e
include graphics.e
include get.e
include mouse.e

constant
   endx=29,
   endy=15,
   endz=7,
   FALSE=0, TRUE=1, EMPTY=0, FULL=1, NOT_OK=0, OK=1,
   NONE=0, QUIT=1, UNDO=2, HINT=3, VIEW_PLAYED=4, NEW_GAME=5,
   LOAD_TILESET=6, LOAD_LAYOUT=7, REPLAY_GAME=8, SELECT=9, VIEW_SET=10,
   CHANGE_COLOR=11,
   button_act = 
   {QUIT,UNDO,HINT,VIEW_PLAYED,NEW_GAME,REPLAY_GAME,LOAD_TILESET,
   LOAD_LAYOUT,VIEW_SET},
   button_loc = 
   {{3,3,66,22},{3,25,66,44},{3,47,66,66},{3,69,66,109},{3,112,66,152},
   {3,155,66,195},{3,198,66,238},{3,241,66,279},{3,282,66,320}},
   master_index =
   "ABCDEFGHIJKLMNOPQRSTUVWXYZ" &
   "abcdefghijklmnopqrstuvwxyz" &
   "1234567890-=~!@#$%^&*()_+`" &
   "{}|:\"<>?[]\\;',./          "

sequence font_index
font_index=repeat(repeat(repeat(0,8),16),104)
sequence deck
deck=repeat(0,144)
sequence images
images=repeat(repeat(repeat(0,40),40),42)
sequence table,layout
table=repeat(repeat(repeat(0,endy),endx),endz)
layout=repeat(repeat(repeat(0,endy),endx),endz)

integer table_count,count,pick,ox,oy,oz,ot,list_count,match_count,move
integer bk_clr
sequence which,oldtile,negative,open_list,matches,background,history
sequence tilename,layoutname,logo,vc,negative1
oldtile=repeat(repeat(0,36),36)
negative=repeat(repeat(0,36),36) negative1=repeat(repeat(0,36),36)
background=repeat(repeat(1,570),323)
history=repeat(repeat(0,8),72)

procedure read_font_data()
integer fp
fp=open("font.dat","rb")
for ch=1 to 104 do
   for r=1 to 16 do
      for c=1 to 8 do
         font_index[ch][r][c]=getc(fp)
      end for
   end for
end for
close(fp)
end procedure

procedure putsxy(integer x,integer y, sequence display_text)
integer font_selected
for ix = 1 to length(display_text) do
   font_selected = find(display_text[ix],master_index)
   if font_selected = 0 then
      font_selected = 104
   end if
   display_image({x,y},font_index[font_selected])
   x=x+8
end for
end procedure

function nx(integer x, integer z)
   return (x-1)*18+(z-1)*4+72
end function

function ny(integer y, integer z)
   return (y-1)*18-(z-1)*4+30
end function

function wait_mouse(sequence list)
object event
while 1 do
   event=get_mouse()
   if sequence(event) then
      if and_bits(event[1],LEFT_DOWN) then
         for f=1 to length(list) do
            if event[2]>=list[f][1] and event[2]<=list[f][3] and
            event[3]>=list[f][2] and event[3]<=list[f][4] then
               return f
            end if
         end for
      end if
   end if
end while
end function

procedure draw_box(integer x1,integer y1,integer x2,integer y2)
draw_line(BRIGHT_WHITE,{{x1,y2},{x1,y1},{x2,y1}})
draw_line(GRAY,{{x2-1,y1+1},{x2-1,y2-1},{x1+1,y2-1}})
draw_line(BLACK,{{x2,y1},{x2,y2},{x1,y2}})
end procedure

procedure draw_inv_box(integer x1,integer y1,integer x2,integer y2)
draw_line(BLACK,{{x1,y2},{x1,y1},{x2,y1}})
draw_line(GRAY,{{x1+1,y2-1},{x1+1,y1+1},{x2-1,y1+1}})
draw_line(BRIGHT_WHITE,{{x2,y1},{x2,y2},{x1+1,y2}})
end procedure

procedure button(integer x1, integer y1, integer x2, integer y2,
   sequence s,integer inv)
integer p,v
mouse_pointer(0)
polygon(7,1,{{x1+1,y1+1},{x2-1,y1+1},{x2-1,y2-1},{x1+1,y2-1}})
p=length(s)
v=floor((y1+y2)/2)
if p=1 then
   putsxy(floor((x2+x1)/2)-floor(length(s[1])*8/2)+inv,v-7+inv,s[1])
else
   putsxy(floor((x2+x1)/2)-floor(length(s[1])*8/2)+inv,v-14+inv,s[1])
   putsxy(floor((x2+x1)/2)-floor(length(s[2])*8/2)+inv,v+inv,s[2])
end if
if inv then
   draw_inv_box(x1,y1,x2,y2)
else
   draw_box(x1,y1,x2,y2)
end if
mouse_pointer(1)
end procedure

procedure inlay(integer x1, integer y1, integer x2, integer y2, sequence text)
mouse_pointer(0)
polygon(7,1,{{x1+1,y1+1},{x2-1,y1+1},{x2-1,y2-1},{x1+1,y2-1}})
draw_line(GRAY,{{x1,y2},{x1,y1},{x2,y1}})
draw_line(BRIGHT_WHITE,{{x2,y1},{x2,y2},{x1+1,y2}})
putsxy(floor((x2+x1)/2)-floor(length(text)*8/2),floor((y1+y2)/2)-8,text)
mouse_pointer(1)
end procedure

procedure message(sequence text)
integer junk
sequence under
mouse_pointer(0)
under=save_image({200,145},{439,213})
draw_line(BRIGHT_WHITE,{{200,213},{200,145},{439,145}})
polygon(7,1,{{202,147},{438,147},{438,212},{202,212}})
draw_box(201,146,439,213)
putsxy(320-floor(length(text)*8/2),159,text)
draw_line(GRAY,{{204,209},{204,149},{435,149}})
draw_line(BRIGHT_WHITE,{{435,149},{435,209},{204,209}})
mouse_pointer(1)
button(294,183,346,203,{"Ok"},0)
junk=wait_mouse({{296,181,344,205}})
button(294,183,346,203,{"Ok"},1)
mouse_pointer(0)
display_image({200,145},under)
mouse_pointer(1)
end procedure

procedure load_layout()
integer fp

table_count=0
fp=open(layoutname,"rb")
for f=1 to endz do
   for h=1 to endx do
      for g=1 to endy do
         layout[f][h][g]=getc(fp)
         if layout[f][h][g]=1 then
            table_count=table_count+1
         end if
      end for
   end for
end for
count=table_count
close(fp)
end procedure

procedure load_images()
integer fp,c

fp=open(tilename,"rb")
for t=1 to 42 do
   for y=1 to 40 do
      for x=1 to 39 by 2 do
         c=getc(fp)
         images[t][y][x]=floor(c/16) -- Grr, I want SHR!!
         images[t][y][x+1]=and_bits(c,#F)
      end for
   end for
end for
close(fp)
end procedure

procedure init_tiles()
integer t,r,index

for f=0 to 33 do
   for g=0 to 3 do
      deck[f*4+g+1]=f+1
   end for
end for
for f=0 to 7 do
   deck[137+f]=35+f
end for
for f=1 to 7 do
   for g=1 to table_count-1 do
      r=rand(table_count)
      t=deck[g]
      deck[g]=deck[r]
      deck[r]=t
   end for
end for
index=1
for f=1 to endz do
   for g=1 to endy do
      for h=1 to endx do
         if layout[f][h][g]=1 then
            table[f][h][g]=deck[index]
            index=index+1
         else
            table[f][h][g]=0
         end if
      end for
   end for
end for
end procedure

procedure display_table()
integer tx,ty
sequence back
back=background
mouse_pointer(0)
for f=1 to endz do
   for h=endx to 1 by -1 do
      for g=1 to endy do
         if table[f][h][g]>0 then
            tx=(h-1)*18+(f-1)*4+2
            ty=(g-1)*18-(f-1)*4+30
            for i=1 to 40 do
               back[ty+i][tx..tx+39]=images[table[f][h][g]][i]
            end for
         end if
      end for
   end for
end for
display_image({70,0},back)
mouse_pointer(1)
end procedure

procedure update_count()
sequence buf
buf=sprintf("Tiles left: %d",count)
inlay(487,326,637,347,buf)
end procedure

procedure disp_select()
if pick=1 then
    inlay(321,326,484,347,"Select first tile")
else
    inlay(321,326,484,347,"Select second tile")
end if
end procedure

procedure main_display()
mouse_pointer(0)
polygon(WHITE,1,{{0,0},{69,0},{69,323},{0,323}})
polygon(WHITE,1,{{0,324},{639,324},{639,349},{0,349}})
draw_line(GRAY,{{0,322},{69,322},{69,0}})
draw_line(BRIGHT_WHITE,{{0,323},{639,323}})
mouse_pointer(1)
button(3,3,66,22,{"Quit"},0)
button(3,25,66,44,{"Undo"},0)
button(3,47,66,66,{"Hint"},0)
button(3,69,66,109,{"View","Played"},0)
button(3,112,66,152,{"New","Game"},0)
button(3,155,66,195,{"Replay","Game"},0)
button(3,198,66,238,{"Load","Tileset"},0)
button(3,241,66,279,{"Load","Layout"},0)
button(3,282,66,320,{"View","Tileset"},0)
inlay(3,326,30,347,"")
mouse_pointer(0)
polygon(bk_clr,1,{{5,328},{28,328},{28,345},{5,345}})
display_image({104,326},logo)
mouse_pointer(1)
update_count()
display_table()
end procedure

-------------------------------------------------------------------------
-- This function is what took me so long to write this program
-------------------------------------------------------------------------
function is_open(integer x, integer y, integer z)
integer left, right, leftadj, rightadj

left=EMPTY -- tile is unblocked initially
right=EMPTY
leftadj=EMPTY
rightadj=EMPTY
if z<endz then -- check if tile is blocked on top (including partially)
   for f=-1 to 1 do
      for g=-1 to 1 do
         if x+f>=2 and x+f<=endx-1 and y+g>=2 and y+g<=endy-1 then
            if table[z+1][x+f][y+g]>0 then -- make sure not off map edge
               return NOT_OK
            end if
         end if
      end for
   end for
end if
if x<=2 or x>=endx-1 then -- if tile is on the map edge, then it is open
   return OK
end if
if table[z][x-2][y]=0 then -- if not blocked by immediate left...
   if y>2 then
      if table[z][x-2][y-1]>=1 then -- partially blocked on top left? 
         leftadj=FULL
      end if
   end if
   if y<endy then
      if table[z][x-2][y+1]>=1 then -- partially blocked on bottom left?
         leftadj=FULL
      end if
   end if
   if leftadj=EMPTY then -- not blocked at all on leftside so it is open
      return OK
   end if
else
   left=FULL
end if
if table[z][x+2][y]=0 then -- if not blocked by immediate right...
   if y>2 then
      if table[z][x+2][y-1]>=1 then -- partially blocked on top right?
         rightadj=FULL
      end if
   end if
   if y<endy then -- partially blocked on bottom right?
      if table[z][x+2][y+1]>=1 then
         rightadj=FULL
      end if
   end if
   if rightadj=EMPTY then -- not blocked at all on rightside so it is open
      return OK
   end if
else
   right=FULL
end if
if left=FULL or leftadj=FULL then -- if left is blocked but not the right...
   if right=EMPTY and rightadj=EMPTY then
      return OK                   -- it's open
   end if
end if
if right=FULL or rightadj=FULL then -- if right is blocked but not the left...
   if left=EMPTY and leftadj=EMPTY then
      return OK                     -- it's open
   end if
end if
return NOT_OK  -- failed all tests, so it is blocked
end function

procedure get_open_tiles()
open_list={}
for f=1 to endx do
   for g=1 to endy do
      for h=endz to 1 by -1 do
         if table[h][f][g]>=1 then
            if is_open(f,g,h)=OK then
               open_list=append(open_list,{h,f,g,table[h][f][g]})
            end if
         end if
      end for
   end for
end for
list_count=length(open_list)
end procedure

procedure get_matches()
integer t1, t2
matches={}
match_count=0
if list_count>=2 then
   for f=1 to list_count-1 do
      t1=open_list[f][4]
      for g=f+1 to list_count do
         t2=open_list[g][4]
         if (t1<=34 and t1=t2) or -- handle regular suits
            ((t1>=35 and t1<=38) and (t2>=35 and t2<=38)) or --handle seasons
            ((t1>=39 and t1<=42) and (t2>=39 and t2<=42)) then -- " flowers
            match_count=match_count+1
            matches=append(matches,{f,g})
         end if
      end for
   end for
end if
end procedure

function get_action()
integer x,y,mx,my,key
object event
while 1 do
   event=get_mouse()
   if sequence(event) then
      if and_bits(event[1],LEFT_DOWN) then
         mx=event[2] my=event[3]
         if my<325 and mx<69 then
            for f=1 to 9 do
               if mx>=button_loc[f][1] and mx<=button_loc[f][3] and
                  my>=button_loc[f][2] and my<=button_loc[f][4] then
                     return button_act[f]
               end if
            end for
         elsif mx>=3 and mx<=30 and my>=326 and my<=347 then
            return CHANGE_COLOR
         else
            for f=endz to 1 by -1 do
               for g=1 to endx do
                  for h=endy to 1 by -1 do
                     if table[f][g][h]>0 then
                        x=(g-1)*18+(f-1)*4+72
                        y=(h-1)*18-(f-1)*4+30
                        if (mx>=x and mx<=(x+39)) and
                           (my>=y and my<=(y+39)) then
                           which={f,g,h}
                           return SELECT
                        end if
                     end if
                  end for
               end for
            end for
            if pick=2 then
               mouse_pointer(0)
               display_image({nx(ox,oz)+4,ny(oy,oz)},oldtile)
               mouse_pointer(1)
               pick=1
               disp_select()
            end if
         end if
      end if
   end if
   key=get_key()
   if key=27 then return QUIT end if
end while
end function

procedure hint()
integer ind,choice,x1,y1,z1,x2,y2,z2
get_open_tiles()
get_matches()
ind=1
if match_count>0 then
   mouse_pointer(0)
   polygon(WHITE,1,{{0,325},{485,325},{485,348},{0,348}})
   putsxy(8,329,"Hint Options:")
   mouse_pointer(1)
   button(120,326,239,347,{"Remove Match"},0)
   button(242,326,361,347,{"Next Match"},0)
   button(364,326,483,347,{"Quit Hint"},0)
   while 1 do
      x1=open_list[matches[ind][1]][2] y1=open_list[matches[ind][1]][3] z1=open_list[matches[ind][1]][1]
      x2=open_list[matches[ind][2]][2] y2=open_list[matches[ind][2]][3] z2=open_list[matches[ind][2]][1]
      for f=1 to 36 do
         negative[f]=15-images[open_list[matches[ind][1]][4]][f][5..40]
      end for
      for f=1 to 36 do
         negative1[f]=15-images[open_list[matches[ind][2]][4]][f][5..40]
      end for
      display_image({nx(x1,z1)+4,ny(y1,z1)},negative)
      display_image({nx(x2,z2)+4,ny(y2,z2)},negative1)
      choice=wait_mouse({{120,326,239,347},{242,326,361,347},{364,326,483,347}})
      if choice=3 then                                                    
         button(364,326,483,347,{"Quit Hint"},1)
         return
      elsif choice=1 then
         button(120,326,239,347,{"Remove Match"},1)
         move=move+1
         history[move]=open_list[matches[ind][1]][4] & z1 & x1 & y1 & 
            open_list[matches[ind][2]][4] & z2 & x2 & y2
         table[z1][x1][y1]=0
         table[z2][x2][y2]=0
         count=count-2
         display_table()
         update_count()
         get_open_tiles()
         get_matches()
         ind=1
         if match_count=0 then
            message("Sorry, no more matches.")
            return
         end if
         button(120,326,239,347,{"Remove Match"},0)
      elsif choice=2 then
         if ind<match_count then
            button(242,326,361,347,{"Next Match"},1)
            ind=ind+1
            display_table()
            button(242,326,361,347,{"Next Match"},0)
         else
            message("Sorry, no more matches.")
            return
         end if
      end if
   end while
else
    message("Sorry, no more matches.")
end if
end procedure

function get_tilename(sequence ext,sequence title)
   integer choice,x1,y1,x2,y2,r,c
   sequence names,locs
   locs={}
   names=dir(ext)
   mouse_pointer(0)
   polygon(WHITE,1,{{0,0},{639,0},{639,349},{0,349}})
   draw_line(GRAY,{{0,320},{639,320}})
   draw_line(BRIGHT_WHITE,{{0,321},{639,321}})
   mouse_pointer(1)
   button(1,325,100,347,{"Cancel"},0)
   inlay(103,325,637,347,"Select "&title&" to load or click cancel")
   for f=1 to length(names) do
      c=floor((f-1)/12)
      r=remainder((f-1),12)
      x1=c*120+3
      y1=r*26+3
      x2=x1+111
      y2=y1+23
      button(x1,y1,x2,y2,{names[f][1]},0)
      locs=append(locs,{x1,y1,x2,y2})
   end for
   locs=append(locs,{1,325,100,348})
   choice=wait_mouse(locs)
   if choice<length(locs) then
      button(locs[choice][1],locs[choice][2],locs[choice][3],locs[choice][4],{names[choice][1]},1)
      return names[choice][1]
   else
      button(1,325,100,347,{"Cancel"},1)
      return -1
   end if
end function

integer junk,act,card,flag,x,y,x1,x2
object obj
----------------------- Main Rountine ------------------------
vc=video_config()
tilename="winmah.til"
layoutname="dragon.tlo"
bk_clr=1
read_font_data()
load_layout()
init_tiles()
load_images()
logo=read_bitmap("logo.bmp")
logo=logo[2]
junk=graphics_mode(16)
main_display()
pick=1
disp_select()
mouse_events(LEFT_DOWN)
mouse_pointer(1)
move=0
act=NONE
while act!=QUIT do
   act=get_action()
   if act=SELECT then
      if pick=1 then
         if is_open(which[2],which[3],which[1])=OK then
            ox=which[2] oy=which[3] oz=which[1] ot=table[oz][ox][oy]
            mouse_pointer(0)
            oldtile=save_image({nx(ox,oz)+4,ny(oy,oz)},{nx(ox,oz)+39,
               ny(oy,oz)+35})
            for f=1 to 36 do
               negative[f]=15-images[ot][f][5..40]
            end for
            display_image({nx(ox,oz)+4,ny(oy,oz)},negative)
            mouse_pointer(1)
            pick=2
            disp_select()
         end if
      elsif pick=2 then
         flag=FALSE
         if is_open(which[2],which[3],which[1])=OK then
            if which[2]!=ox or which[3]!=oy or which[1]!=oz then
               card=table[which[1]][which[2]][which[3]]
               if (card<=34 and card=ot) or
                  ((card>=35 and card<=38) and (ot>=35 and ot<=38)) or
                  ((card>=39 and card<=42) and (ot>=39 and ot<=42)) then 
                  table[which[1]][which[2]][which[3]]=0
                  table[oz][ox][oy]=0
                  flag=TRUE
                  move=move+1
                  history[move]=ot & oz & ox & oy & card & which
                  count=count-2
                  display_table()
                  update_count()
                  if count=0 then
                     message("Curses, YOU WIN!")
                     act=NONE
                  end if
                  get_open_tiles()
                  get_matches()
                  if match_count=NONE and act!=NONE then
                     message("Sorry, no more matches.")
                  end if
               end if
            end if
         end if
         if flag=FALSE then
            mouse_pointer(0)
            display_image({nx(ox,oz)+4,ny(oy,oz)},oldtile)
            mouse_pointer(1)
         end if
         pick=1
         disp_select()
      end if
   elsif act=UNDO then
      button(3,25,66,44,{"Undo"},1)
      if count!=144 then
         count=count+2
         table[history[move][2]][history[move][3]][history[move][4]]=history[move][1]
         table[history[move][6]][history[move][7]][history[move][8]]=history[move][5]
         move=move-1
         pick=1
         display_table()
         update_count()
         disp_select()
      else
         message("Nothing to undo.")
      end if
      button(3,25,66,44,{"Undo"},0)
   elsif act=HINT then
      button(3,47,66,66,{"Hint"},1)
      hint()
      display_table()
      mouse_pointer(0)
      polygon(WHITE,1,{{0,325},{485,325},{485,348},{0,348}})
      mouse_pointer(1)
      inlay(3,326,30,347,"")
      mouse_pointer(0)
      polygon(bk_clr,1,{{5,328},{28,328},{28,345},{5,345}})
      display_image({104,326},logo)
      mouse_pointer(1)
      pick=1
      disp_select()
      button(3,47,66,66,{"Hint"},0)
   elsif act=NEW_GAME then
      button(3,112,66,152,{"New","Game"},1)
      init_tiles()
      display_table()
      count=table_count
      update_count()
      button(3,112,66,152,{"New","Game"},0)
      pick=1
      disp_select()
      move=0
   elsif act=REPLAY_GAME then
      button(3,155,66,195,{"Replay","Game"},1)
      count=1
      for f=1 to endz do
         for h=1 to endy do
            for g=1 to endx do
               if layout[f][g][h]=1 then
                  table[f][g][h]=deck[count]
                  count=count+1
               end if
            end for
         end for
      end for
      count=table_count
      move=0
      pick=1
      display_table()
      update_count()
      disp_select()
      button(3,155,66,195,{"Replay","Game"},0)
   elsif act=VIEW_PLAYED then
      button(3,69,66,109,{"View","Played"},1)
      if move!=0 then
         mouse_pointer(0)
         polygon(bk_clr,1,{{0,0},{639,0},{639,323},{0,323}})
         polygon(WHITE,1,{{0,324},{639,324},{639,349},{0,349}})
         draw_line(BRIGHT_WHITE,{{0,323},{639,323}})
         x=20
         y=10
         for f=1 to move do
            display_image({x,y},images[history[f][1]])
            display_image({x+5,y+5},images[history[f][5]])
            x=x+50
            if x>=601 then
               x=20
               y=y+50
            end if
         end for
         mouse_pointer(1)  
         button(153,326,487,347,{"Click here to return to the main screen"},0)
         junk=wait_mouse({{153,326,487,347}})
         button(153,326,487,347,{"Click here to return to the main screen"},1)
         pick=1
         main_display()
         disp_select()
      else
         message("No tiles have been played.")
         button(3,69,66,109,{"View","Played"},0)
      end if
   elsif act=LOAD_TILESET then
      button(3,198,66,238,{"Load","Tileset"},1)
      obj=get_tilename("*.til","tilename")
      if sequence(obj) then
         tilename=obj
         load_images()
      end if
      pick=1
      main_display()
      disp_select()
   elsif act=LOAD_LAYOUT then
      button(3,241,66,279,{"Load","Layout"},1)
      obj=get_tilename("*.tlo","layout")
      if sequence(obj) then
         layoutname=obj
         load_layout()
         init_tiles()
      end if
      pick=1
      main_display()
      disp_select()
   elsif act=VIEW_SET then
      button(3,282,66,320,{"View","Tileset"},1)
      mouse_pointer(0)
      polygon(WHITE,1,{{0,0},{639,0},{639,349},{0,349}})
      putsxy(5,45,"Dots")
      putsxy(5,110,"Bamboo")
      putsxy(5,175,"Characters")
      putsxy(5,237,"Winds")
      putsxy(255,237,"Dragons")
      putsxy(5,302,"Seasons")
      putsxy(255,302,"Flowers")
      for f=1 to 3 do
         for g=1 to 9 do
            display_image({50*(g-1)+5,65*(f-1)+5},images[g+(f-1)*10])
         end for
         display_image({50*(f-1)+255,195},images[f*10])
      end for
      for f=0 to 3 do
         display_image({50*f+5,195},images[31+f])
         display_image({50*f+5,260},images[35+f])
         display_image({50*f+255,260},images[39+f])
      end for
      draw_line(GRAY,{{0,320},{639,320}})
      draw_line(BRIGHT_WHITE,{{0,321},{639,321}})
      mouse_pointer(1)
      button(153,326,487,347,{"Click here to return to the main screen"},0)
      junk=wait_mouse({{153,326,487,347}})
      button(153,326,487,347,{"Click here to return to the main screen"},1)
      pick=1
      main_display()
      disp_select()
   elsif act=CHANGE_COLOR then
      obj={}
      polygon(WHITE,1,{{0,325},{485,325},{485,348},{0,348}})
      for f=0 to 15 do
         x1=f*30+3
         x2=f*30+30
         inlay(x1,326,x2,347,"")
         mouse_pointer(0)
         polygon(f,1,{{x1+2,328},{x2-2,328},{x2-2,345},{x1+2,345}})
         mouse_pointer(1)
         obj=append(obj,{x1,326,x2,348})
      end for
      bk_clr=wait_mouse(obj)-1
      background=repeat(repeat(bk_clr,570),323)
      main_display()
      pick=1
      disp_select()
   end if
end while
mouse_pointer(0)
junk=graphics_mode(vc[VC_MODE])
inlay(3,326,30,347,"")

